Investigate using cmake for configuration
Status: In Progress Start date: 20 Jun 2014

Priority: Normal Due date:  

Assignee: John Abbott % Done: 10%

Category: Portability Estimated time: 0.00 hour

Target version: CoCoALib-1.0 Spent time: 2.45 hours

Description

The cmake program offers a platform independent "configuration" mechanism.  In principle it could replace CoCoA's existing rather

elaborate configuration arrangement.

Is cmake appropriate for CoCoALib/CoCoA?  Investigate!

Related issues:

Related to CoCoALib - Design #752: Investigate using Boost.build instead of make New 30 Jul 2015

History

#1 - 20 Jun 2014 09:18 - John Abbott

Christof has been investigating using cmake for configuring normaliz/libnormaliz.

Good cmake seems to handle dependencies correctly and automatically; also the CMakeLists.txt file allows one to express fairly clearly(?!?) the

structure of the project.

Bad it is not clear how to specify a custom "installation" of GMP instead of the standard system one; it is not clear how to extract the compilation

options from GMP so that they can be used for the whole project.

Right now I find the negative aspects quite discouraging, almost to the point of declaring cmake unsuitable for CoCoALib (but that would be

premature).  I do not much like the idea of discard all the work put into the current shell-script+makefile system (but I also think that make is pretty

terrible).

#2 - 20 Jun 2014 15:00 - Anna Maria Bigatti

John Abbott wrote:

Bad it is not clear how to specify a custom "installation" of GMP instead of the standard system one; it is not clear how to extract the compilation

options from GMP so that they can be used for the whole project.

Right now I find the negative aspects quite discouraging, almost to the point of declaring cmake unsuitable for CoCoALib (but that would be

premature).  I do not much like the idea of discard all the work put into the current shell-script+makefile system (but I also think that make is

pretty terrible).

 

I agree: we do need to allow custom installation of gmp (and boost)

We cannot give up make if we cannot rewrite the same functionalities with cmake.

Let's Christof work a bit longer on it ;-)
#3 - 23 Jun 2014 17:40 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

Christof is still trying to make cmake behave well on MacOS; both static and dynamic libraries give (different) problems.

He has not yet found a way of getting the -m64 compilation flag out of GMP.  Probably in a few years' time it will all be irrelevant, but currently we still

have to deal with awkward OSes (like mine) which don't really know whether they're 64-bit or 32-bit... :-(

cmake seemed to handle a fairly awkward directory name without trouble.

#4 - 28 Apr 2017 11:30 - Anna Maria Bigatti

- Project changed from CoCoA to CoCoALib

- Category changed from Portability to Portability

- Assignee set to John Abbott

- Target version set to CoCoALib-1.0

If I recall well someone (ICMS Seoul) suggested us to keep our handwritten configure.

This issue was under "CoCoA" instead of "CoCoALib".

I'm recovering these old and forgotten issues, so we reconsider them.

#5 - 28 Apr 2017 13:35 - John Abbott

We should talk to the Normaliz people again to see what they think of cmake after some time using it.  I thought I had heard that they were

abandoning cmake (in favour of "autotools"?)

#6 - 13 Mar 2024 21:19 - John Abbott

This has been dormant for 7 years.  Should we close/reject it?
